{$I tttvers.pas}
unit jmwave;
{Ausgerichtete Recordfelder aus!!!}
{$A-}

interface

uses forms, //fr application
     //dialogs,
     sysutils, //fileexists
     Classes, mmsystem, WinProcs;
const sampl441 = 441; //fr eine 1/100-Sekunde
  Anzahl_stereokanaele = 8;
  sampl22050 = 50*sampl441; //22050
type
  TRiffHeader = record
    riff: Array[0..3] OF Char;
    filesize: LongInt;
    typeStr: Array[0..3] OF Char;
  end;
  TChunkRec = record
    id: Array[0..3] OF Char;
    size: LongInt;
  end;
  TWaveFormatRec = record
    tag: Word;
    channels: Word;
    samplesPerSec: LongInt;
    bytesPerSec: LongInt;
    blockAlign: Word;
  end;
  TPCMWaveFormatRec = record
    wf: TWaveFormatRec;
    bitsPerSample: Word;
  end;
  TWAVHeader = record { WAV Format }
    riffHdr: TRiffHeader;
    fmtChunk: TChunkRec;
    fmt: TPCMWaveFormatRec;
    dataChunk: TChunkRec;
    { data follows here }
  end;

var o0,o1,o2,o3,o4,o5:integer; // obertne
    kato:double;               //Kammerton
procedure spiele(fr1, fr2, fr3, fr4, fr5, fr6, fr7, fr8: double; cs: Cardinal);
                                                            //cs=CentiSekuns
procedure mehrklang;
procedure EinzelnerTon;

implementation
uses FileCtrl,jmhilf,jminput,unmu1;

procedure HeadInit(var Header: TWAVHeader);
begin
  with Header do
  begin
    with riffHdr do
    begin
        //Schreibe 'RIFF' in die ersten 4 bytes
      riff[0] := char($52); riff[1] := char($49); riff[2] := char($46); riff[3] := char($46);
        // wird spaeter gesetzt;
      filesize := 0;
        //Schreibe 'WAVE' in die naechsten 4 bytes
      typeStr[0] := char($57); typeStr[1] := char($41); typeStr[2] := char($56); typeStr[3] := char($45);
    end;
    with fmtChunk do
    begin
        //Schreibe 'fmt' + char($20) in die naechsten 4 bytes
      id[0] := char($66); id[1] := char($6D); id[2] := char($74); id[3] := char($20);
      size := $10;
    end;
    with fmt.wf do
    begin
        //its 16 bit, 44kHz Stereo
      tag := 1; channels := 2;
      samplesPerSec := $AC44;
      bytesPerSec := MakeLong($B110, $2);
      blockAlign := 4;
      fmt.bitsPerSample := $10;
    end;
    with dataChunk do
    begin
        //Schreibe 'data' in die naechsten 4 bytes
      id[0] := char($64); id[1] := char($61); id[2] := char($74); id[3] := char($61);
      size := 0;
    end;
  end;
end;

function f0(const k: double): SmallInt; //k=i*Frequ i:=0 to ...
begin
  if form1.cbsinus.checked then
    result := Round(sin(k*Pi/sampl22050)*32000/Anzahl_stereokanaele)
    //               Frequenz        Amplitude
  else if form1.cbrechteck.checked then Begin
    if odd(round(k / (sampl22050))) then result := 4000 else result := -4000;
  End else with form1 do Begin
    result :=                       Round(sin(  k*Pi/sampl22050)*o0/Anzahl_stereokanaele);
   //siehee TForm1.edit1Change                          o0:=32000*100 div sum;
    if o1>0 then result := result + Round(sin(2*k*Pi/sampl22050)*o1/Anzahl_stereokanaele);
   //                                                    o1:=32000*o1  div sum; //1. Oberton
    if o2>0 then result := result + Round(sin(3*k*Pi/sampl22050)*o2/Anzahl_stereokanaele);
    if o3>0 then result := result + Round(sin(4*k*Pi/sampl22050)*o3/Anzahl_stereokanaele);
    if o4>0 then result := result + Round(sin(5*k*Pi/sampl22050)*o4/Anzahl_stereokanaele);
    if o5>0 then result := result + Round(sin(6*k*Pi/sampl22050)*o5/Anzahl_stereokanaele);
  End;
end;


function Abtastwert(const k1,k2,k3,k4,k5,k6,k7,k8: double): SmallInt; //
  var f:Smallint;
begin //z.B. k=i*frw1 (fr i=441*500(5Sek) frw1=100)=max=sampl220500000
                                           //Longword=0..4294967295
  if k1=0 then Begin result:=0; exit End else f:=f0(k1);
  result:=f;
  if k2=0 then exit;
  if k2<>k1 then f:=f0(k2); //else f=f0(k1)
  result:=result+f;
  if k3=0 then exit;
  if k3<>k2 then f:=f0(k3); //else f=f0(k2)
  result:=result+f;
  if k4=0 then exit;
  if k4<>k3 then f:=f0(k4); //else f=f0(k3)
  result:=result+f;
  if k5=0 then exit;
  if k5<>k4 then f:=f0(k5); //else f=f0(k4)
  result:=result+f;
  if k6=0 then exit;
  if k6<>k5 then f:=f0(k6); //else f=f0(k5)
  result:=result+f;
  if k7=0 then exit;
  if k7<>k6 then f:=f0(k7); //else f=f0(k6)
  result:=result+f;
  if k8=0 then exit;
  if k8<>k7 then result:=result+f0(k8) else result:=result+f;
end;


procedure spiele(fr1, fr2, fr3, fr4, fr5, fr6, fr7, fr8: double; cs: Cardinal); //cs=CentiSekuns
     const Ausgabekanal_wird_bereits_verwendet = 'Ausgabekanal wird bereits verwendet!';
var ms: TMemoryStream;
  Header: TWavHeader;
  i: integer; //z.B. i=0 to 441*500=441500 (5 Sekunden)
  s: SmallInt;
  schongeladen: boolean;
  unterverzeichnis,filena:string;
begin
  if form1.cbspeichern.checked then with Form1 do Begin
    filena:=ssd_(fr1,1);
    if fr2>0 then filena:=filena+ssd_(fr2,1);
    if fr3>0 then filena:=filena+ssd_(fr3,1);
    if fr4>0 then filena:=filena+ssd_(fr4,1);
    if fr5>0 then filena:=filena+ssd_(fr5,1);
    if fr6>0 then filena:=filena+ssd_(fr6,1);
    if fr7>0 then filena:=filena+ssd_(fr7,1);
    if fr8>0 then filena:=filena+ssd_(fr8,1);
    for i:=1 to length(filena) do if filena[i]=',' then
      filena[i]:='-';
    unterverzeichnis:='wav\'+ssd_(cs,1)+
                      edit1.text+edit2.text+edit3.text+edit4.text+edit5.text;
    if cbrechteck.checked then unterverzeichnis:=unterverzeichnis+'r';

  End else Begin
    filena:='';
    unterverzeichnis:=''
  End;
  HeadInit(Header);
  Header.Datachunk.size := sampl441 * cs * 2 * 2; //441*cs Samples pro sekunde,
                                                //2 Channels, 2Bytes (16bit)
  //FileSize = DataSize + HeaderSize
  Header.riffHdr.FileSize := Header.Datachunk.size + 24;
  ms := TMemoryStream.Create;
  schongeladen := true;
  if filena > '' then Begin
    try
      if fileexists(exepfad + unterverzeichnis+'\'+filena + '.wav') then
      ms.LoadFromFile(exepfad + unterverzeichnis+'\'+filena + '.wav')
      else schongeladen := false;
    except schongeladen := false; ENd
  End Else schongeladen := false;
  try
    if not schongeladen then Begin
      ms.Seek(0, 0);
      //Write Header to Stream
      ms.Write(Header, sizeof(header));
      //form here: just data chunks. in this case (16bit stereo):
      // 16bit LeftValue, 16bit Right Value, 16bit LeftValue, 16bit Right Value ...
      // in the range of a SmallInt
      if cs <= 0 then exit; //kein Ton. Sollte nicht vorkommen
      for i := 0 to sampl441 * cs - 2 do BEgin
        //Writing left channel
        s := Abtastwert(i * fr1, i * fr2, i * fr3, i * fr4,
                        i * fr5, i * fr6, i * fr7, i * fr8);
        ms.Write(s, 2);
        //Writing to right channel
        ms.Write(s, 2);
      ENd;
      if filena > '' then BEgin
        forcedirectories(exepfad+unterverzeichnis);
        ms.SaveToFile(exepfad + unterverzeichnis+'\'+filena + '.wav');
      ENd;
    End;
  Finally
      if not sndPlaySound(ms.Memory, SND_MEMORY or SND_SYNC) then
        ; //ok(Ausgabekanal_wird_bereits_verwendet);
    ms.Free;
  End;
    { sndPlaySound(ms.Memory, SND_MEMORY or SND_ASYNC or SND_LOOP)
       fhrt bei WinNT zu Fehler. Deshalb dort nur snd_sync
       sndPlaySound(ms.Memory, SND_MEMORY or SND_SYNC or SND_LOOP) }
end;

Procedure AenderKlangfarbe(eing: string; var eingabetoene:String);
  var k:integer;
      eingabeklang:string;
begin
  k := pos('(',eing);
  if k>0 then Begin
    eingabetoene := copy(eing,1,k-1);
    eingabeklang := copyab(eing,k+1);
    k := pos(')',eingabeklang);
    if k > 0 then eingabeklang := copy(eingabeklang,1,length(eingabeklang) - 1);
    with Form1 do Begin
      edit1.Text :=  wort_n(eingabeklang,1);
      edit2.Text :=  wort_n(eingabeklang,2);
      edit3.Text :=  wort_n(eingabeklang,3);
      edit4.Text :=  wort_n(eingabeklang,4);
      edit5.Text :=  wort_n(eingabeklang,5);
      application.ProcessMessages;
    ENd;
  End else eingabetoene := eing;
end;

procedure EinzelnerTon;
var k: double;
  eing, eingabetoene: string;
begin
  if toene.count>0 then eing :=toene[0];
  if eing = '' then eing := '440';
  repeat
    if not jminput1('Ein Ton','Geben Sie die Frequenz ein',
    'Sie knnen fr die Klangfarbe, d.h. die  Obertne'#13+
    'im Hauptprogramm einstellen oder'#13+
    'in Klammer hinter die Frequenz z.B.'#13+
    '440 (75 50 0 0 0)',eing,Toene) then Begin
      sndPlaySound(nil, 0);
      exit;
    End;
    AenderKlangfarbe(eing, eingabetoene);
    k := rr_(eingabetoene,1);
    spiele(k, 0, 0, 0, k, 0, 0, 0, 300);
  until false;
end;

procedure mehrklang;
var oo: array [1..8] of  double;
  eing, eingabetoene: string;
     k:integer;
begin
  if klaenge.count>0 then eing := klaenge[0];
  if eing = '' then eing := '440 550 660 880';
  repeat
    if not jminput1('maximal acht Frequenzen','Geben Sie die Frequenzen ein',
    'Sie knnen fr die Klangfarbe, d.h. die  Obertne'#13+
    'im Hauptprogramm einstellen oder'#13+
    'in Klammer hinter die Frequenz z.B.'#13+
    '440 550 660 880 (75 50 25 12 6)',eing,klaenge) then Begin
      sndPlaySound(nil, 0);
      exit;
    End;
    AenderKlangfarbe(eing, eingabetoene);
    for k:=1 to 8 do
      oo[k] := rr_(eingabetoene,k);
    spiele(oo[1],oo[2],oo[3],oo[4],oo[5], oo[6], oo[7], oo[8], 300);
  until false;
end;


end.

